// uni-app请求封装
import store from '@/store/index.js'
import {TOKEN_KEYAuto} from '@/utils/courseTool.js'
export default class Request {
	http(router, data = {}, method,contentType) {
		let that = this;
		// let path ='https://storeuserapp.bjyjbao.com/store'//本地
			// let path ='http://p6c668f9.natappfree.cc/store'//本地
		// let path ='https://storeuserapp.bjyjbao.com/store'//本地
		// let path = 'https://userapp.bjyjbao.com/store'//医 健宝
		let path = 'http://tad99bfb.natappfree.cc/store'//张圆圆
		// let path = 'http://yd966f99.natappfree.cc/store'//汪于杰

		let type = 0
		uni.setStorageSync('requestPath',path)
		// uni.showLoading({
		// 	title: '加载中'
		// });
		let token = uni.getStorageSync('AppToken');
		if(router.indexOf("/companyapp")!=-1){
			// router =router.replace('/companyapp','')
			path = 'https://userapp.bjyjbao.com'//医 健宝
			// path = 'http://ub86b489.natappfree.cc'//医 健宝
			 type = 1
			 token = uni.getStorageSync('ManageToken');
		}
		// 企微看课
		if(router.indexOf("/course_auto")!=-1){
			type = 2
			router =router.replace('/course_auto','')
			// path = 'http://ra9c6f7f.natappfree.cc'
			path = 'https://userapp.bjyjbao.com'//医 健宝
			token =uni.getStorageSync(TOKEN_KEYAuto)
			console.log("TOKEN_KEYAuto===",TOKEN_KEYAuto,token)
		}
		if(router.indexOf("/course_uniapp")!=-1){
			type = 3
			router =router.replace('/course_uniapp','')
			// path = 'http://vc69777a.natappfree.cc'
			path = 'https://userapp.bjyjbao.com'//医 健宝
			token =uni.getStorageSync('TOKEN_WEXIN')
		}
		return new Promise((resolve, reject) => {
			// token = uni.getStorageSync('AppToken');
			var httpContentType='application/x-www-form-urlencoded';
			if(contentType!=undefined){
				//application/json;charset=UTF-8
				httpContentType=contentType;
			}
			var routers=router;
			// 请求
			uni.request({
				header: {
					// 'Content-Type': 'application/x-www-form-urlencoded',
					'Content-Type': httpContentType,
					'AppToken': token
				},
				url: `${path}${router}`,
				data: data,
				method: method,
				success: (res) => {
					if(type !==0&&(res.data.code == 401 || res.data.code == 4001||res.data.code == 4004)) {
						store.commit('setCoureLogin', 2);
						uni.removeStorageSync("userinfos")
						uni.removeStorageSync('userInfo');
						uni.removeStorageSync('TOKEN_WEXIN');
						if(type==2) {
							uni.removeStorageSync(TOKEN_KEYAuto)
						}
						if(type==1) {
							uni.removeStorageSync('ManageToken');
							uni.navigateTo({
								url:'/pages_manage/login'
							})
						}
						resolve({ code: 401, data: null });
						return
					}
					//收到开发者服务器成功返回的回调函数
					if(res.data.code==401){//没有权限直接退出到登录界面
						let pages = getCurrentPages();
						pages.forEach(function(element) {
						  if(element!=undefined&&element.route=="pages/auth/login"){
						  	resolve(res.data)
						  	return;
						  }
						});
						// let url = pages[ pages.length - 1]; //当前页页面实例
						// //如果登录界面已打开,自动关闭
						// if(url!=undefined&&url.route=="pages/auth/login"){
						//  	resolve(res.data)
						// 	return;
						// }
						uni.navigateTo({
							url:'/pages/auth/login',
							success: () => {
								uni.hideLoading();
								
							},
							fail: () => {
								uni.hideLoading();
							}
						})
						return;
					}
					if (res.data.token&&type==0) {
						uni.setStorageSync('AppToken',res.data.token)
					}
					resolve(res.data)
				},
				fail:(res) =>{
					//接口调用失败的回调函数
				},
				complete:(res) =>{
					//接口调用结束的回调函数（调用成功、失败都会执行）
					if (res.data.code == 401) {
						return false
					}
					uni.hideLoading();
				}
				
			})
		})
		 
	}
	
}
